//       

#include<stdio.h>
#include<malloc.h>
#include<memory.h>
#include<string.h>

typedef unsigned char byte;

//!    
struct MyChar{
	size_t size;				//!  
	union {
		char *ref;
		char txt[sizeof(char*)];
	};
};

//!    
namespace Allocator_str{
	void New(MyChar *,char *);		//!<   
	void Free(MyChar*);				//!<  
	char *Get(MyChar*);				//!<   
};


//! \param    
//! \param txt     
void Allocator_str::New(MyChar *str,char *txt)
{
	str->size=strlen(txt);
	if(str->size>sizeof(char*)) {
		str->ref=(char*)malloc(str->size);
		memcpy(str->ref,txt,str->size);
	}else memcpy(str->txt,txt,str->size);
}

void Allocator_str::Free(MyChar *str)
{
	if(str->size>sizeof(char*)) free(str->ref);
}

char *Allocator_str::Get(MyChar *str)
{
	return str->size>sizeof(char*)?str->ref:str->txt;
}


void ShowStr(MyChar *str)
{
	char *ref=Allocator_str::Get(str);
	for(size_t n=0; n<str->size; n++) putchar(ref[n]);
	putchar('\n');
}


void main()
{
	MyChar str1,str2;
	Allocator_str::New(&str1,"Hi)");
	Allocator_str::New(&str2,"Hello!");
	ShowStr(&str1);
	ShowStr(&str2);
	Allocator_str::Free(&str1);
	Allocator_str::Free(&str2);
}

